package com.javatunes.persist.client;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.TypedQuery;

import com.javatunes.persist.MusicItem;

public class JPATest {
	public static void main(String[] args) {
		EntityManagerFactory emf = Persistence.createEntityManagerFactory("javatunes"); 
		EntityManager em = emf.createEntityManager();
		EntityTransaction tx = null;
		try {
			tx = em.getTransaction();
			tx.begin();
			
			// Find / retrieve an instance
			MusicItem m = em.find(MusicItem.class, new Long(1));
			System.out.println(m);
			System.out.println("Date type = " + m.getReleaseDate().getClass().getName());
			
			// Insert / persist an instance
			MusicItem newItem = new MusicItem();
			newItem.setArtist("Cat Stevens");
			newItem.setNum("CD525");
			newItem.setTitle("Tea for the Tillerman");
			newItem.setPrice(new BigDecimal("14.97"));
			newItem.setReleaseDate(new Date());
			em.persist(newItem);
			System.out.println("Before Commit");
			tx.commit();
			System.out.println("newItem.id = " + newItem.getId());
			
			// Remove an instance
			tx = em.getTransaction();
			tx.begin();
			m = em.find(MusicItem.class, new Long(1));
			m.setTitle("This is a new title");
			tx.commit();
			
			// Modify an instance
			tx = em.getTransaction();
			tx.begin();
			m = em.find(MusicItem.class, new Long(1));
			System.out.println("Music Item with id = 1 - should have new title");
			System.out.println(m);
			tx.commit();			
		} 
		catch (Exception ex) { ex.printStackTrace(); }
		finally { em.close(); }
	}
}
