package com.javatunes.persist.client;

import java.math.BigDecimal;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.FlushModeType;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

import com.javatunes.persist.MusicItem;

public class JPATest {
	public static void main(String[] args) {
		EntityManagerFactory emf = Persistence.createEntityManagerFactory("javatunes"); 
		EntityManager em = emf.createEntityManager();
		EntityTransaction tx = null;
		try {
			tx = em.getTransaction();
			tx.begin();

			// Uncomment for flush mode = COMMIT
			// em.setFlushMode(FlushModeType.COMMIT);
			MusicItem anItem = em.find(MusicItem.class, new Long(1));
			anItem.setPrice(new BigDecimal("19.99"));
			TypedQuery<MusicItem> q = em.createQuery("SELECT m FROM MusicItem m WHERE m.price > 18.99 ", MusicItem.class);
		    List<MusicItem> resultList = q.getResultList();
		    System.out.println("***** Results from retrieving music items with price > 18.99 *********");
		    for (MusicItem curItem : resultList) {
		    	System.out.println(curItem);
		    }
			em.getTransaction().commit();

		} 
		catch (Exception ex) { ex.printStackTrace(); }
		finally { em.close(); }
	}
}
