package com.javatunes.persist.client;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import com.javatunes.persist.MusicItem;

public class JPATest {
	public static void main(String[] args) {
		EntityManagerFactory emf = Persistence.createEntityManagerFactory("javatunes"); 
		EntityManager em = null;
		try {
			// Detached object / versioning example.
			
			// Get an object, and close the EM so it is detached.
			em = emf.createEntityManager();
			em.getTransaction().begin();
			MusicItem detachedItem = em.find(MusicItem.class, new Long(1));
			System.out.println("detached item: version = " + detachedItem.getVersion());
			em.getTransaction().commit();
			em.close();

			// Get the same object (with a new EM) and modify it.
			em = emf.createEntityManager();
			em.getTransaction().begin();
			MusicItem managedItem = em.find(MusicItem.class, new Long(1));
			System.out.println("managed item before modify: version = " + managedItem.getVersion());
			managedItem.setTitle(managedItem.getTitle() + "x");
			em.getTransaction().commit();
			System.out.println("managed item after modify: version = " + managedItem.getVersion());			
			em.close();
			
			// Try to merge in the detached object - it should throw an exception.
			em = emf.createEntityManager();
			em.getTransaction().begin();
			em.merge(detachedItem);
			em.getTransaction().commit();
			em.close();
		} 
		catch (Exception ex) { ex.printStackTrace(); }
	}
}
