package com.javatunes.persist.client;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

import com.javatunes.persist.MusicItem;

public class JPATest {
	public static void main(String[] args) {
		EntityManagerFactory emf = Persistence.createEntityManagerFactory("javatunes"); 
		EntityManager em = emf.createEntityManager();
		try {
			
			// A find which returns a DownloadableItem
			em.getTransaction().begin();
			MusicItem mi = em.find(MusicItem.class, new Long (1));
			System.out.println("Results of find on id=1");
			System.out.println(mi);
			em.getTransaction().commit();
			
			// Polymorphic query
			em.getTransaction().begin();
			TypedQuery<MusicItem> tq = em.createQuery("SELECT mi FROM MusicItem mi", MusicItem.class);
			System.out.println("\n******\n");
			System.out.println("Results of polymorphic query on all items");
			for (MusicItem curItem : tq.getResultList()) {
				System.out.println(curItem);
			}
		} 
		catch (Exception ex) { ex.printStackTrace(); }
		finally { em.close(); }
	}
}
