package com.javatunes.persist.client;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

import com.javatunes.persist.MusicItem;

public class JPATest {
	public static void main(String[] args) {
		EntityManagerFactory emf = Persistence.createEntityManagerFactory("javatunes"); 
		EntityManager em = emf.createEntityManager();
		try {
			
			em.getTransaction().begin();

			// Using named query (defined in orm.xml)
		    TypedQuery<MusicItem> q = em.createNamedQuery("MusicItem.findByArtist", MusicItem.class);
		    q.setParameter("artist", "Sting");
		    List<MusicItem> resultList = q.getResultList();
		    System.out.println("***** Results from named query on Sting *********");
		    for (MusicItem curItem : resultList) {
		    	System.out.println(curItem);
		    }
		    q.setParameter("artist", "Madonna");
		    resultList = q.getResultList();
		    System.out.println("***** Results from named query on Madonna *********");
		    for (MusicItem curItem : resultList) {
		    	System.out.println(curItem);
		    }			
			
			em.getTransaction().commit();

		} 
		catch (Exception ex) { ex.printStackTrace(); }
		finally { em.close(); }
	}
}
