/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.javatunes.persist;

import java.util.Collection;
import javax.persistence.EntityManager;
import javax.persistence.TypedQuery;

/**
 * Class to manage JPA interaction for MusicItems
 * Note that it does not implement the full complement of possible methods that might be needed
 * It is for illustration purposes only
 */
public class MusicItemDAO {

    private EntityManager getEntityManager() {
        return JpaUtil.getEntityManager();
    }

    public void create (MusicItem item) {
        getEntityManager().persist(item);
    }

    public MusicItem findById(Long id) {
        return getEntityManager().find(MusicItem.class, id);
    }

    public MusicItem merge(MusicItem item) {
        return getEntityManager().merge(item);
    }

    public Collection<MusicItem> findByArtist(String artistIn) {
        TypedQuery<MusicItem> q = getEntityManager().createNamedQuery("MusicItem.findByArtist", MusicItem.class);
        q.setParameter("artist", artistIn);
        return q.getResultList();
    }

    public Collection<MusicItem> getAll() {
        TypedQuery<MusicItem> q = getEntityManager().createQuery("SELECT m FROM MusicItem m", MusicItem.class);
        return q.getResultList();
    }
}
