/*
 * This code is sample code, provided as-is, and we make no
 * warranties as to its correctness or suitablity for
 * any purpose.
 *
 * We hope that it's useful to you.  Enjoy.
 * Copyright 2006-10 LearningPatterns Inc.
 */
 
package com.javatunes.persist.client;

import com.javatunes.persist.JpaUtil;
import java.math.BigDecimal;

import com.javatunes.persist.MusicItem;
import com.javatunes.persist.MusicItemDAO;
import java.util.Collection;
import java.util.Date;

public class JPATest {
    public static void main(String[] args) {
        MusicItemDAO dao = new MusicItemDAO();
        try {
            Collection<MusicItem> resultList = null;

            JpaUtil.beginTransaction();
            resultList = dao.findByArtist("Sting");
            System.out.println("***** Results from artist query on Sting *********");
            for (MusicItem curItem : resultList) {
                System.out.println(curItem);
            }
            resultList = dao.findByArtist("Madonna");
            System.out.println("***** Results from artist query on Madonna *********");
            for (MusicItem curItem : resultList) {
                System.out.println(curItem);
            }
            JpaUtil.commitTransaction();

            JpaUtil.beginTransaction();
            // Insert / persist an instance
            MusicItem newItem = new MusicItem();
            newItem.setArtist("Cat Stevens");
            newItem.setNum("CD525");
            newItem.setTitle("Tea for the Tillerman");
            newItem.setPrice(new BigDecimal("14.97"));
            newItem.setReleaseDate(new Date());
            dao.create(newItem);
            JpaUtil.commitTransaction();

            // Modify an instance
            JpaUtil.beginTransaction();
            MusicItem m = dao.findById(new Long(1));
            JpaUtil.commitTransaction();

            // Modify an instance using another business object
            JpaUtil.beginTransaction();
            m.setTitle("This is a completely new title");
            ItemUpdateService update = new ItemUpdateService();
            update.update(m);
            JpaUtil.commitTransaction();

            JpaUtil.beginTransaction();
            m = dao.findById(new Long(1));
            System.out.println("Music Item with id = 1 - should have new title");
            System.out.println(m);
            JpaUtil.commitTransaction();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        finally {
            JpaUtil.closeEntityManager();
        }
    }
}
