/*
 * This code is sample code, provided as-is, and we make no
 * warranties as to its correctness or suitablity for
 * any purpose.
 *
 * We hope that it's useful to you.  Enjoy.
 * Copyright 2006-7 LearningPatterns Inc.
 */


package com.javatunes.jpa.catalog;

import javax.ejb.Stateless;
import javax.ejb.Remote;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;


import com.javatunes.jpa.catalog.MusicItem;

/**
 * This class is a stateless session bean that uses JPA to access data in a database.
 * It is a session facade around the JPA functionality
 */

@Stateless
@Remote(MusicItemServiceRemote.class)
public class MusicItemServiceBean implements MusicItemServiceRemote {

   // TODO: Add in an EntityManager reference
   // TODO: The name of the persistence unit is from your persistence.xml file
	
   @PersistenceContext(unitName="catalog")
   EntityManager em;


   // searches catalog by ID
   public MusicItem findById(Long id)
   {
	   // TODO: Find the item using the EntityManager and return it
	   return em.find(MusicItem.class,id);
   }

   // Add item to catalog
   public Long addItem(MusicItem item) {
      // TODO: Persist the item using the EntityManager reference
      // TODO: Return the item ID after you persist the item
	   em.persist(item);
	   em.flush();
	   return item.getId();
   }

   // Update title
   public void updateTitle(Long id, String newTitle) {
      // TODO: Retrieve the item using EntityManager.find
	  // TODO: Set the title to the passed in value
	   MusicItem found = em.find(MusicItem.class,id);
	   found.setTitle(newTitle);	   
   }

}
